//------------------------------------------------------
// module  : FunctionVOIBFM.cc
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionVOIBFM.h"


//--------------------------//
//-- Matrice de Flottant ---//
//--------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; 
 }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//-----------------------//
//-- Matrice d'entiers --//
//-----------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de int
//----------------------------------------------------------
int*** imatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  int*** matrix;

  matrix=new int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=imatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//---------------------------//
//--- Liberation memoire ----//
//---------------------------//
//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_imatrix_3d(int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }



//--------------------//
//-- Matrix Gestion --//
//--------------------//
//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(int** mat1,int** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float** mat1,int** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(int** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat1[i][j]=(int)mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float*** mat1,float*** mat2,int lgth,int wdth)
{
  int i,j,k;

  for(k=0;k<3;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[k][i][j]=mat2[k][i][j]; 
}

/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void Recal(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (max) mat[i][j]*=(GREY_LEVEL/max);      
}

/*----------------------------------------------------------*/
/* Zeros                                                    */
/*----------------------------------------------------------*/
void Zeros(float** mat,int lgth,int wdth)
{
 int i,j;

 //Fill Zeros
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  mat[i][j]=0.0;
}

//----------------------------------------------------------
// calcule le nombre de differences a chaque iteration
//----------------------------------------------------------
int DiffMatNb(int** pmatl1,int** pmatl2,int lgth,int wdth)
{
 int i,j;
 int chg;

 //>Compte NbChgt
 chg=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (pmatl1[i][j]!=pmatl2[i][j]) chg++; 
       
 return chg;
}



//--------------//
// RANDOM ------//
//--------------//
//----------------------------------------------------------
// retourne un nombre aleatoire entre zero et un
//----------------------------------------------------------
float randomize(void)
{ return ((float)rand()/RAND_MAX); }


//----------//
//-- FILE --//
//----------//
//----------------------------------------------------------
// Get Length and Width
//----------------------------------------------------------
void GetLengthWidth(char* path,int* length,int* width)
{
 unsigned char var;
 int   temp;
 char* tempc;
 char stringTmp1[100];
 char stringTmp2[100];
 int ta1,ta2;
 FILE *fic;

  //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL)
    { printf("\n- Grave erreur a l'ouverture de %s -\n",path);
      exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic);
  for(;;) { temp=fread(&var,1,1,fic); if (var==35) tempc=fgets(stringTmp2,100,fic);
            else break; }
  fseek(fic,-1,SEEK_CUR);
  temp=fscanf(fic,"%d %d",&ta1,&ta2);
   
  //enregistrement
  (*length)=ta2; 
  (*width)=ta1;

  //fermeture du fichier
  fclose(fic);
}

//----------------------------------------------------------
// Chargement de l'image de nom <name> (en ppm)             
//----------------------------------------------------------
void load_image_ppm(char* path,int*** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char varb,varv,varr;

  char stringTmp1[200],stringTmp2[200];
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   if (strstr(path,".ppm")==NULL) strcat(path,".ppm");

   //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic); //P6
  tempc=fgets(stringTmp2,100,fic); //Comment

  for(;;)
    { if (((int)stringTmp2[0]==10)||((int)stringTmp2[0]==35))
      tempc=fgets(stringTmp2,100,fic); 

      else break; }

  temp=sscanf(tempc," %d %d",&ta1,&ta2);
  temp=fscanf(fic," %d",&ta3);

  //affichage de l'entete
  printf("\n\n -- Entete --");
  printf("\n ------------");
  //printf("\n %s %s %d %d \n %d",stringTmp1,stringTmp2,ta1,ta2,ta3);
  printf("\n %s  %d %d \n %d",stringTmp1,ta1,ta2,ta3);
  printf("\n ----------------------------------------------------------\n\n");
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<(wdth*3);j+=3)  
    { temp=fread(&varr,1,1,fic);
      temp=fread(&varv,1,1,fic);
      temp=fread(&varb,1,1,fic);
     
      img[2][i][j/3]=varr;        
      img[0][i][j/3]=varv;        
      img[1][i][j/3]=varb; }      

  //fermeture du fichier
  fclose(fic);
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,int** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,int*** matrvb,int wdth,int lgth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n  >> Sauvegarde dans -> %s au format %s",buff,".ppm");
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",lgth,wdth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<wdth;i++) for(j=0;j<lgth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }


//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,float*** matrvb,int wdth,int lgth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n  >> Sauvegarde dans -> %s au format %s",buff,".ppm");
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",lgth,wdth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<wdth;i++) for(j=0;j<lgth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }

//----------------------------------------------------------
// Sauvegarde du Tab. d''image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveTabImagePgm(char* path,char* name,float*** mat,int lgth,int wdth,int nb)
{
  int i,j,k,l;
 char buff[300];
 FILE* fic;
 float NbPic;
 int   LgthNb,WdthNb;
 int nbimg;

  //--extension--
  strcpy(buff,path);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--Memory---
  NbPic=(int)((sqrt(nb)-0.1)+1.0);
  LgthNb=lgth*(int)NbPic;
  WdthNb=wdth*(int)NbPic;
  //printf("\n [<%d>]",(int)NbPic);
  float** MatImg=fmatrix_allocate_2d(LgthNb,WdthNb);

  //--Load--
  for(i=0;i<LgthNb;i++) for(j=0;j<WdthNb;j++) MatImg[i][j]=0.0;

  nbimg=-1;
  for(k=0;k<(int)NbPic;k++) for(l=0;l<(int)NbPic;l++)
     { nbimg++;
       if (nbimg>(nb-1)) break;
       for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
         MatImg[(k*lgth)+i][(l*wdth)+j]=mat[nbimg][i][j]; }

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n  >> Sauvegarde de %s au format pgm",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",WdthNb,LgthNb);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<LgthNb;i++) for(j=0;j<WdthNb;j++) 
	fprintf(fic,"%c",(char)MatImg[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 

  //Liberation Memoire
  if (MatImg) free_fmatrix_2d(MatImg);
}

//----------------------------------------------------------
// Sauvegarde du Tab. d''image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveTabImagePgm(char* path,char* name,int*** mat,int lgth,int wdth,int nb)
{
  int i,j,k,l;
 char buff[300];
 FILE* fic;
 float NbPic;
 int   LgthNb,WdthNb;
 int nbimg;

  //--extension--
  strcpy(buff,path);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--Memory---
  NbPic=(int)((sqrt(nb)-0.1)+1.0);
  LgthNb=lgth*(int)NbPic;
  WdthNb=wdth*(int)NbPic;
  //printf("\n [<%d>]",(int)NbPic);
  float** MatImg=fmatrix_allocate_2d(LgthNb,WdthNb);

  //--Load--
  for(i=0;i<LgthNb;i++) for(j=0;j<WdthNb;j++) MatImg[i][j]=0.0;

  nbimg=-1;
  for(k=0;k<(int)NbPic;k++) for(l=0;l<(int)NbPic;l++)
     { nbimg++;
       if (nbimg>(nb-1)) break;
       for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
         MatImg[(k*lgth)+i][(l*wdth)+j]=mat[nbimg][i][j]; }

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n  >> Sauvegarde de %s au format pgm",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",WdthNb,LgthNb);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<LgthNb;i++) for(j=0;j<WdthNb;j++) 
	fprintf(fic,"%c",(char)MatImg[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 

  //Liberation Memoire
  if (MatImg) free_fmatrix_2d(MatImg);

}

//--------------------
//-- SPACE COLOR -----
//--------------------
//----------------------------------------------------------*/
// RGBToHSV 
// --------
// H=[0::360]   S=[0::1]  V=[0::255]
//                        
//----------------------------------------------------------*/
void RGBToHSV(float r,float g,float b,float* h,float* s,float* v)
{
 float maxRGB=MAX(MAX(r,g),MAX(g,b));
 float minRGB=MIN(MIN(r,g),MIN(g,b));

 (*v)=maxRGB;                                                

 if (maxRGB==0)   (*s)=0.0;
 else             (*s)= (maxRGB-minRGB)/maxRGB;                    

        
 if ((*s)==0)     (*h)=0.0;                                              
 else
    { if (r==maxRGB)       (*h)=(g-b)/(maxRGB-minRGB);    
      else if (g==maxRGB)  (*h)=2+(b-r)/(maxRGB-minRGB);
      else                 (*h)=4+(r-g)/(maxRGB-minRGB);

      (*h)*=60;           
      if ((*h)<0.0)        (*h)+=360;  }
}

//----------------------------------------------------------*/
// RGBToYIQ  
//
//  |Y|  |0.299   0.587   0.114| |R|
//  |I|= |0.596  -0.275  -0.321| |G|
//  |Q|  |0.212  -0.523   0.311| |B|
//
//  Y=[0::1]
//  I=[-0.5957161349127745527::0.5957161349127745527]
//  Q=[-0.5225910452916111684::0.5225910452916111684]
//                   
//----------------------------------------------------------*/
void RGBToYIQ(float r,float g,float b,float* y,float* i,float* q)
{
  //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  b/=255.0;

  //Conversion
 (*y)=(0.299*r)+(0.587*g) +(0.114*b);
 (*i)=(0.596*r)+(-0.275*g)+(-0.321*b);
 (*q)=(0.212*r)+(-0.523*g)+(0.311*b);

 //Result
 if (0)
    {
      (*y)*=255.0;
      (*i)=(((*i)+0.6)/1.20)*255.0;
      (*q)=(((*q)+0.6)/1.20)*255.0; 
    }
}

//----------------------------------------------------------*/
// RGBToXYZ  
//
//   [ X ]   [  0.412453  0.357580  0.180423 ] [ R ] 
//   [ Y ] = [  0.212671  0.715160  0.072169 ] [ G ]
//   [ Z ]   [  0.019334  0.119193  0.950227 ] [ B ].
//
// [X,Y,Z] = [0::255]
//                   
//----------------------------------------------------------*/
void RGBToXYZ(float r,float g,float b,float* x,float* y,float* z)
{
  //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  b/=255.0;

  //Conversion
 (*x)=(0.412453*r)+(0.357580*g)+(0.180423*b);
 (*y)=(0.212671*r)+(0.715160*g)+(0.072169*b);
 (*z)=(0.019334*r)+(0.119193*g)+(0.950227*b);

  //RGB 
 (*x)*=255.0;
 (*y)*=255.0;
 (*z)*=255.0;

  //Tests
 if ((*x)>255)  (*x)=255;
 if ((*x)<0)    (*x)=0;

 if ((*y)>255)  (*y)=255;
 if ((*y)<0)    (*y)=0;

 if ((*z)>255)  (*z)=255;
 if ((*z)<0)    (*z)=0;
}

//----------------------------------------------------------*/
//  XYZtoRGB 
//
//   [ R ]   [  3.240479 -1.537150 -0.498535 ] [ X ]
//   [ G ] = [ -0.969256  1.875992  0.041556 ] [ Y ]
//   [ B ]   [  0.055648 -0.204043  1.057311 ] [ Z ].
//
// [R,G,B] = [0::255]
//                   
//----------------------------------------------------------*/
void XYZToRGB(float x,float y,float z,float* r,float* g,float* b)
{
  //XYZ en [0-1]
  x/=255.0;
  y/=255.0;
  z/=255.0;

  //Conversion
 (*r)=(3.240479*x)+(-1.537150*y)+(-0.498535*z);
 (*g)=(-0.969256*x)+(1.875992*y)+(0.041556*z);
 (*b)=(0.055648*x)+(-0.204043*y)+(1.057311*z);

 //RGB en [0-255]
 (*r)*=255.0;
 (*g)*=255.0;
 (*b)*=255.0;

 //Tests
 if ((*r)>255)  (*r)=255;
 if ((*r)<0)    (*r)=0;

 if ((*g)>255)  (*g)=255;
 if ((*g)<0)    (*g)=0;

 if ((*b)>255)  (*b)=255;
 if ((*b)<0)    (*b)=0;
}

//----------------------------------------------------------*/
// RGBToLAB  
//
// LAB = [0::100][-85::110][0::255]
//
//
//        L* = 116 * (Y/Yn)1/3 - 16    for Y/Yn > 0.008856
//        L* = 903.3 * Y/Yn             otherwise
//
//        a* = 500 * ( f(X/Xn) - f(Y/Yn) )
//        b* = 200 * ( f(Y/Yn) - f(Z/Zn) )
//            where f(t) = t1/3      for t > 0.008856
//                      f(t) = 7.787 * t + 16/116    otherwise
//                   
//----------------------------------------------------------*/
void RGBToLAB(float r,float g,float bl,float* l,float* a,float* b)
{
 float x,y,z;
 float xn,yn,zn;

 //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  bl/=255.0;

 //Conversion RGB->XYZ
  RGBToXYZ(r,g,bl,&x,&y,&z);
  RGBToXYZ(1.0,1.0,1.0,&xn,&yn,&zn);

 //Conversion XYZ->LAB
  if ((y/yn)>0.008856)  (*l)=116.0*pow((y/yn),(1.0/3.0))-16.0;
  else                  (*l)=903.3*(y/yn);

  if ((x/xn)>0.008856)  (*a)=500.0*(pow((x/xn),(1.0/3.0)));
  else                  (*a)=7.787*(x/xn)+16.0/116.0;

  if ((y/yn)>0.008856)  (*a)-=500.0*(pow((y/yn),(1.0/3.0)));
  else                  (*a)-=7.787*(y/yn)+16.0/116.0;

  if ((y/yn)>0.008856)  (*b)=500.0*(pow((y/yn),(1.0/3.0)));
  else                  (*b)=7.787*(y/yn)+16.0/116.0;

  if ((z/zn)>0.008856)  (*b)-=500.0*(pow((z/zn),(1.0/3.0)));
  else                  (*b)-=7.787*(z/zn)+16.0/116.0;
}

//----------------------------------------------------------*/
// RGBToLUV  
//
// LUV = [0::100][-86::164][-131::116]
//  
//        L* =  116 * (Y/Yn)1/3 - 16
//        u* =  13L* * ( u' - un' )
//        v* =  13L* * ( v' - vn' )
//
//      un' = 0.2009 
//      vn' = 0.4610 
//
//        u' = 4X / (X + 15Y + 3Z) = 4x / ( -2x + 12y + 3 )
//        v' = 9Y / (X + 15Y + 3Z) = 9y / ( -2x + 12y + 3 ).
//
//       x = 27u' / ( 18u' - 48v' + 36 )
//       y = 12v' / ( 18u' - 48v' + 36 ).
//               
//----------------------------------------------------------*/
void RGBToLUV(float r,float g,float bl,float* l,float* u,float* v)
{
 float x,y,z;
 float xn,yn,zn;
 float uprime,vprime;

 //Init
 uprime=0.0;
 vprime=0.0;

 //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  bl/=255.0;

 //Conversion RGB->XYZ
  RGBToXYZ(r,g,bl,&x,&y,&z);
  RGBToXYZ(1.0,1.0,1.0,&xn,&yn,&zn);

  //Calcul uprime/vprime
  if (x+(15*y)+(3*z))
   { uprime=(4*x)/(x+(15*y)+(3*z));
     vprime=(9*y)/(x+(15*y)+(3*z)); }

 //Conversion XYZ->LUV
 (*l)=116.0*pow((y/yn),(1.0/3.0))-16.0;
 (*u)=13*(*l)*(uprime-0.2009);
 (*v)=13*(*l)*(vprime-0.4610);
}

//----------------------------------------------------------*/
// LUVToRGB  
//
//  u' = u / ( 13L*) + un
//  v' = v / ( 13L* ) + vn
//  Y = (( L* + 16 ) / 116 )3
//  X = - 9Yu' / (( u' - 4 ) v' - u'v' )
//  Z = ( 9Y - 15v'Y - v'X ) / 3v' 
//
//      un' = 0.2009 
//      vn' = 0.4610 
//                   
//----------------------------------------------------------*/
void LUVToRGB(float l,float u,float v,float* r,float* g,float* bl)
{
 float x,y,z;
 float uprime,vprime;

 //Conversion LUV->XYZ
 uprime=u/(13*l)+0.2009;
 vprime=v/(13*l)+0.4610;
 
 y=pow(((l+16)/116),3.0);
 x=-9*y*uprime/(((uprime-4)*vprime)-uprime*vprime);
 z=((9*y-15*vprime*y-vprime*x)/(3*vprime));

 //Conversion XYZ->RGB
 XYZToRGB(x,y,z,r,g,bl);

 //RGB en [0-255]
 (*r)*=255.0;
 (*g)*=255.0;
 (*bl)*=255.0;

 //Tests
 if ((*r)>255)  (*r)=255;
 if ((*r)<0)    (*r)=0;

 if ((*g)>255)  (*g)=255;
 if ((*g)<0)    (*g)=0;

 if ((*bl)>255)  (*bl)=255;
 if ((*bl)<0)    (*bl)=0;
}

//----------------------------------------------------------*/
// RGBToI1I2I3  
//
// I1=(1/3) (R+G+B)
// I2=(R-B)
// I3=(2G-R-B)/2
//                   
//----------------------------------------------------------*/
void RGBToI1I2I3(float r,float g,float bl,float* i1,float* i2,float* i3)
{

  //Conversion RGB -> I1I2I3
  (*i1)=(1.0/3.0)*(r+g+bl);
  (*i2)=(r-bl);
  (*i3)=((1.0/2.0)*(2*g-r-bl));
}

//----------------------------------------------------------*/
// RGBToH1H2H3  
//
// H1= R+G
// H2= R-G
// H3= B- (1.0/2.0)(R+G)
//                   
//----------------------------------------------------------*/
void RGBToH1H2H3(float r,float g,float bl,float* h1,float* h2,float* h3)
{

  //Conversion RGB -> H1H2H3
  (*h1)=(r+g);
  (*h2)=(r-g);
  (*h3)=(bl-(1.0/2.0)*(r+g));
}

//----------------------------------------------------------*/
// RGBToTSL
//
// rp=r-(1.0/3.0);
// gp=g-(1.0/3.0);
//
//  L=(1.0/2.0)* [MAX(r,g,b)+MIN(r,g,bl)] 
//
//  Si  (gp>0)  T=((1.0/(2*PI))*atan(rp/gp))+0.25
//  Si  (gp<0)  T=((1.0/(2*PI))*atan(rp/gp))+0.75
//  Si  (!gp)   T=0.0
//
//  S=sqrt[ (9.0/5.0) (rp^2 +gp^2) ]
//                   
//----------------------------------------------------------*/
void RGBToTSL(float r,float g,float bl,float* t,float* s,float* l)
{

 float rp,gp;
 
 //RGB en [0-1]
 r/=255.0;
 g/=255.0;
 bl/=255.0;

 //r/gprime
 rp=r-(1.0/3.0);
 gp=g-(1.0/3.0);

 //min/maxRGB
 float maxRGB=MAX(MAX(r,g),MAX(g,bl));
 float minRGB=MIN(MIN(r,g),MIN(g,bl));

 //Conversion RGB -> HSV
 (*l)=(1.0/2.0)*(maxRGB+minRGB);

 if (gp>0)  (*t)=((1.0/(2*PI))*atan(rp/gp))+0.25;
 if (gp<0)  (*t)=((1.0/(2*PI))*atan(rp/gp))+0.75;
 if (!gp)   (*t)=0.0;
 if (*t<0)  (*t)=0.0;

 (*s)=sqrt((9.0/5.0)*(CARRE(rp)+CARRE(gp)));
}

//----------------------------------------------------------*/
// RGBToYCbCr
//
//  Y=(0.2989*r)+(0.5866*g)+(0.1145*bl);
//  Cb=(bl-Y)/(2-2*0.1145);
//  Cr=(r-Y)/(2-2*0.2989);
//
//                   
//----------------------------------------------------------*/
void RGBToYCbCr(float r,float g,float bl,float* Y,float* Cb,float* Cr)
{  
 //Conversion RGB -> YCbCr
 (*Y)=(0.2989*r)+(0.5866*g)+(0.1145*bl);
 (*Cb)=(bl-(*Y))/(2-2*0.1145);
 (*Cr)=(r-(*Y))/(2-2*0.2989);
}

//----------------------------------------------------------*/
// RGBToHSL
//
//  H=ACOS[ 0.5(r-g)+(r-b)) / sqrt[ (r-g)^2=(r-b)*(g-b) ] ]
// 
//  L=(1.0/2.0)* [MAX(r,g,b)+MIN(r,g,bl)] 
//
// if (l<=0.5) S=MAX(r,g,b)-MIN(r,g,b)/(MAX(r,g,b)+MIN(r,g,b))
// if (l>0.5)  S=MAX(r,g,b)-MIN(r,g,b)/(2-(MAX(r,g,b)+MIN(r,g,b)))
//                   
//----------------------------------------------------------*/
void RGBToHSL(float r,float g,float bl,float* h,float* s,float* l)
{
 float tmp1,tmp2;

 //RGB en [0-1]
 r/=255.0;
 g/=255.0;
 bl/=255.0;

 //min/maxRGB
 float maxRGB=MAX(MAX(r,g),MAX(g,bl));
 float minRGB=MIN(MIN(r,g),MIN(g,bl));

 //Conversion RGB -> HSV
 tmp1=(0.5)*((r-g)+(r-bl));
 tmp2=sqrt((CARRE(r-g))+(r-bl)*(g-bl));
 if (tmp2) (*h)=acos(tmp1/tmp2);
 else      (*h)=0.0;
 
 (*l)=(1.0/2.0)*(maxRGB+minRGB);

  (*s)=0.0;
  if ((*l)<=0.5) if(maxRGB+minRGB) (*s)=(maxRGB-minRGB)/(maxRGB+minRGB);
  if ((*l)>0.5)  (*s)=(maxRGB-minRGB)/(2.0-(maxRGB+minRGB));

 if isnan(*(h)) *h=0.0;
 if isnan(*(s)) *s=0.0;
 if isnan(*(l)) *l=0.0;  
}

//----------------------------------------------------------*/
// RGBToP1P2
//
//  P1=(1.0/sqrt(2))*(g-r)/sumRGB;
//  P2=(1.0/sqrt(6))*(2*bl-r-g)/sumRGB;
//
//                   
//----------------------------------------------------------*/
void RGBToP1P2(float r,float g,float bl,float* P1,float* P2,float* P3)
{  
 float sumRGB=(r+g+bl);

 //Init
 (*P1)=0.0;
 (*P2)=0.0;

 //Conversion RGB -> P1P2
 if (sumRGB) (*P1)=(1.0/sqrt(2.0))*(g-r)/sumRGB;
 if (sumRGB) (*P2)=(1.0/sqrt(6.0))*(2*bl-r-g)/sumRGB;
 (*P3)=0.0;

 //Verif
 if isnan(*P1) (*P1)=0.0;
 if isnan(*P2) (*P2)=0.0;
}

//---------------
//---K-MEAN------
//---------------
//----------------------------------------------------------
// Identical                      
//----------------------------------------------------------
int Identical(int* VctPts,int** MtxCtrs,int nbcl,int nbpar)
{
 int k,l;
 int value=0;

 for(k=0;k<nbcl;k++) 
   { value=1;
     for(l=0;l<nbpar;l++) if (VctPts[l]!=MtxCtrs[k][l]) value=0;
     if (value) return value; }
    
 return value;
}

//----------------------------------------------------------
//  K-Mean  
//    Avec Entiers
//----------------------------------------------------------
void KmeanFast(int** MatrixPts,int NbClusters,int NbPts,int NbParam,int* VctLabel,int Seed,int FlgMan)
{
 int i,j,k,l;
 int classe;
 float aleat;
 int nb;
 float  dist,distmin;
 int flag;
 
 //Allocation memoire
 int** MatrixCtrs=imatrix_allocate_2d(NbClusters,NbParam);
 
 //Presentation
 printf("\n  <Seed:%d> -> Funct.Kmean",Seed);
 srand(Seed);
 if (FlgMan) printf("\n  K-Moy > [Dist. Manhattan]"); 


 //--------------------------------------------------------------
 // -[0]- Initialize Centroid
 // --------------------------------------------------------------
  if (0)                    
  for(i=0;i<NbClusters;i++) 
     { aleat=(i+1)*(NbPts/(NbClusters+2));
       for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 

  if (1)
  for(i=0;i<NbClusters;i++) 
   { nb=0;
     do { aleat=(int)((randomize())*NbPts-1); nb++; }
     while((i)&&(nb<100)&&(Identical(MatrixPts[(int)aleat],MatrixCtrs,NbClusters,NbParam)));

     if (nb>1) printf(" <|%d Essais|>",nb);

     for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 
  //------------------------------------------------------------------
  //------------------------------------------------------------------
    
 
  printf("\n    ");
 //================================================================
 //BOUCLE =========================================================
 //================================================================
 for(l=0;l<50;l++)
   {  
       //-[1]- Select Cluster Membership
       //-------------------------------
       flag=0; classe=0;

       for(j=0;j<NbPts;j++)
          { distmin=BIGNUMBER;  

           for(i=0;i<NbClusters;i++)
              { dist=0.0; 
                
                //Euclidean distance
                if (!FlgMan)
                for(k=0;k<NbParam;k++) dist+=CARRE(MatrixCtrs[i][k]-MatrixPts[j][k]);

                //Manhattan distance
		if (FlgMan)
                for(k=0;k<NbParam;k++) dist+=abs(MatrixCtrs[i][k]-MatrixPts[j][k]);
		     
                if (dist<distmin) { distmin=dist; classe=i; }
	      }            
           if (VctLabel[j]!=classe) { VctLabel[j]=classe; flag++; }
	  }

       //-[2]- Stop Criterion & Info
       //---------------------------
       if ((!flag)&&(l>2))  break;
       printf("[%d>%d]",l,flag); fflush(stdout);
          
       
       //-[3]- Update Centroids For Each Clusters
       //----------------------------------------
        for(i=0;i<NbClusters;i++) 
	  {  
           nb=0;    
	   for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=0;
                      
	   for(j=0;j<NbPts;j++) if (VctLabel[j]==i)
	      { nb++;
                for(k=0;k<NbParam;k++) MatrixCtrs[i][k]+=MatrixPts[j][k]; }

           for(k=0;k<NbParam;k++) if (nb) MatrixCtrs[i][k]/=nb;
          }

   }//==============================================================
 //================================================================= 

 //FreeMemory
 if (MatrixCtrs) free_imatrix_2d(MatrixCtrs);
}

//----------------------------
//----<HISTO><COLOR-BASE>-----
//----------------------------
//----------------------------------------------------------
//  Segmentation <Histo-COLOR-> Kmean
//
//  image[lgth][wdth] 
//     NbClass / Histo divise en <div> bin with SizeWindow: <SzW>
// 
//  COLbase::
//  -----------            
//  -0- RGB ->    [X,Y,Z] = [0,255]
//  -1- HSV ->    H=[0::360]  S=[0::1]   V=[0::255]
//  -2- YIQ -     Y=[0::1]    I=[-0.55::0.55]  Q=[-0.4::0.4]
//  -3- XYZ ->    [X,Y,Z] = [0,255]
//  -4- LAB -     L=[0::100]    A=[-128::143]  B=[-258::237]
//  -5- LUV -     L=[-16::100]  U=[-60::145]   V=[-130::117]    
//  -6- i123-     i1=[0::255]    i2=[-255::255]      i3=[-255::255]  
//  -7- h123-     h1=[0::510]    h2=[-255::255]      h3=[-255::255]
//  -8- YCbCr    Y=[0::255]     Cb=[-127.5::127.5]  Cr=[-127.5::127.5]
//  -9- TSL-      T=[0::1]       S=[0::1.265]        L=[0::1]
//
//  -10-HSL-      H=[0::3.142]   S=[0::1]            L=[0::1]    
//  -11- P1P2     P1=[-0.707::0.707]   P2=[-0.408::0.816]   
//
//  Recalage sur [0-255] avec :: (C-min)*255/(max-min)
//
//----------------------------------------------------------     
//----------------------------------------------------------     
// SegmentationHistoCOLORKmean Avec Entier 
//----------------------------------------------------------     
void SegmentationHistoCOLORKmeanFast(int***  img,float** matout,int lgth,int wdth,int NbClass,int div,int SzW,int Seed,int bascol)
{
 int i,j,k,l;
 int nbpts; 
 int posr,posc;
 float divis;
 float lab;
 float col1,col2,col3;

 //Init
 int NbParam=div*div*div; 
 divis=(256.0/(float)div);  
 
 //Initialisatio memoire
 int** PtsTab=imatrix_allocate_2d(lgth*wdth,NbParam);
 float*** SquWin=fmatrix_allocate_3d(3,SzW,SzW);
 float*** ImgColorSpace=fmatrix_allocate_3d(3,lgth,wdth);
 int*  TabLabel=imatrix_allocate_1d(NbParam);
 int* VctLabel=imatrix_allocate_1d(lgth*wdth);  

 //Presentation
 printf("\n   >>> SegmentationHisto-COLOR-Kmean");
 printf("[NbCl:%d][Div:%d][Ws:%d][Col:%d][Par:%d]",NbClass,div,SzW,bascol,NbParam); 
 if (bascol==0)  printf(" >RGB");
 if (bascol==1)  printf(" >HSV");
 if (bascol==2)  printf(" >YIQ");
 if (bascol==3)  printf(" >XYZ");
 if (bascol==4)  printf(" >LAB");
 if (bascol==5)  printf(" >LUV");
 if (bascol==6)  printf(" >I1I2I3");
 if (bascol==7)  printf(" >H1H2H3");
 if (bascol==8)  printf(" >YCbCr");
 if (bascol==9)  printf(" >TSL");
 if (bascol==10) printf(" >HSL"); 
 if (bascol==11) printf(" >P1P2"); 
 fflush(stdout);
 
 //-------------------------------------------------------------------------
 //Conversion
 //-------------------------------------------------------------------------
 if (bascol==0)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { ImgColorSpace[0][i][j]=img[0][i][j];
      ImgColorSpace[1][i][j]=img[1][i][j];
      ImgColorSpace[2][i][j]=img[2][i][j]; }

 if (bascol==1)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToHSV(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3); 
      ImgColorSpace[0][i][j]=(col1/360.0)*255.0;
      ImgColorSpace[1][i][j]=col2*255.0;
      ImgColorSpace[2][i][j]=col3; }

 if (bascol==2)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToYIQ(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3); 
      ImgColorSpace[0][i][j]=col1*255.0;
      ImgColorSpace[1][i][j]=((col2+0.55)/1.10)*255.0;
      ImgColorSpace[2][i][j]=((col3+0.4)/0.8)*255.0; }

 if (bascol==3)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToXYZ(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1;
      ImgColorSpace[1][i][j]=col2;
      ImgColorSpace[2][i][j]=col3; }

 if (bascol==4)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToLAB(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1*2.55;
      ImgColorSpace[1][i][j]=((col2+128)/271.0)*255.0;
      ImgColorSpace[2][i][j]=((col3+258)/495.0)*255.0; }

 if (bascol==5)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   {  RGBToLUV(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=((col1+16)/250.0)*255.0;
      ImgColorSpace[1][i][j]=((col2+60)/205.0)*255.0;
      ImgColorSpace[2][i][j]=((col3+130)/247.0)*255.0; }

 if (bascol==6)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToI1I2I3(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1;
      ImgColorSpace[1][i][j]=((col2+255)/2.0);
      ImgColorSpace[2][i][j]=((col3+255)/2.0);  }

 if (bascol==7)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToH1H2H3(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1/2.0; 
      ImgColorSpace[1][i][j]=((col2+255)/2.0); 
      ImgColorSpace[2][i][j]=((col3+255)/2.0); }

 if (bascol==8)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToYCbCr(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1; 
      ImgColorSpace[1][i][j]=col2+127.5; 
      ImgColorSpace[2][i][j]=col3+127.5; }

 if (bascol==9)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToTSL(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1*255;
      ImgColorSpace[1][i][j]=255*col2/1.265; 
      ImgColorSpace[2][i][j]=col3*255;  }

 if (bascol==10)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToHSL(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=255*col1/3.142;  
      ImgColorSpace[1][i][j]=col2*254;
      ImgColorSpace[2][i][j]=col3*255; }

 if (bascol==11)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToP1P2(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=(col1+0.707)*255.0/1.414; 
      ImgColorSpace[1][i][j]=(col2+0.408)*255.0/1.224; 
      ImgColorSpace[2][i][j]=0.0; }


 //Debug
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   { if (ImgColorSpace[0][i][j]>255)  ImgColorSpace[0][i][j]=255.0;
     if (ImgColorSpace[1][i][j]>255)  ImgColorSpace[1][i][j]=255.0;
     if (ImgColorSpace[2][i][j]>255)  ImgColorSpace[2][i][j]=255.0;
     if (ImgColorSpace[0][i][j]<0)    ImgColorSpace[0][i][j]=0.0;
     if (ImgColorSpace[1][i][j]<0)    ImgColorSpace[1][i][j]=0.0;
     if (ImgColorSpace[2][i][j]<0)    ImgColorSpace[2][i][j]=0.0; }
 //-------------------------------------------------------------------------- 
  

 //---------------------------------------------------------------
 //Data   
 //----------------------------------------------------------------                       
 nbpts=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    {
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { 
	 posr=i-(SzW/2)+k;
         posc=j-(SzW/2)+l;

         if (posr<0)           posr+=lgth;
         if (posr>(lgth-1))    posr-=lgth;  
         if (posc<0)           posc+=wdth;
         if (posc>(wdth-1))    posc-=wdth;
        
         SquWin[0][k][l]=ImgColorSpace[0][posr][posc];
         SquWin[1][k][l]=ImgColorSpace[1][posr][posc];
         SquWin[2][k][l]=ImgColorSpace[2][posr][posc];  
        }

     //DataStructure
     for(k=0;k<NbParam;k++)  TabLabel[k]=0;
      
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
	{ lab=((int)(SquWin[0][k][l]/divis))*(div*div);
          lab+=((int)(SquWin[1][k][l]/divis))*(div);  
          lab+=((int)(SquWin[2][k][l]/divis));  
          TabLabel[(int)(lab)]++; }
    
     for(k=0;k<NbParam;k++)    PtsTab[nbpts][k]=TabLabel[k];

     nbpts++;     
    }//----------------------------------------------------------------

 //K-Mean    
 KmeanFast(PtsTab,NbClass,(lgth*wdth),NbParam,VctLabel,Seed,1);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  matout[i][j]=VctLabel[(i*wdth)+j];    

 //Liberation Memoire
 if (PtsTab)         free_imatrix_2d(PtsTab);
 if (SquWin)         free_fmatrix_3d(SquWin,3);
 if (TabLabel)       free_imatrix_1d(TabLabel);
 if (VctLabel)       free_imatrix_1d(VctLabel);
 if (ImgColorSpace)  free_fmatrix_3d(ImgColorSpace,3);
}

//----------------------------------------------------------     
// SegmentationHistoCOLORKmeanG Avec Entier 
//
// Mettre>> div=10 SzW=7
//
//----------------------------------------------------------     
void SegmentationHistoCOLORKmeanFastG(int***  img,float** matout,int lgth,int wdth,int NbClass,int div,int SzW,int Seed,int bascol)
{
 int i,j,k,l;
 int nbpts; 
 int posr,posc;
 float lab;
 float col1,col2,col3;

 //Init
 int NB_GRADBINS=div;
 int NB_PARAM=4*NB_GRADBINS; 
 
 //Initialisatio memoire
 int***    MatxText=imatrix_allocate_3d(NB_PARAM,lgth,wdth);
 float**   MatxNB=fmatrix_allocate_2d(lgth,wdth);
 float**   MatxHor=fmatrix_allocate_2d(lgth,wdth);
 float**   MatxVer=fmatrix_allocate_2d(lgth,wdth);
 float**   MatxDgd=fmatrix_allocate_2d(lgth,wdth);
 float**   MatxDgg=fmatrix_allocate_2d(lgth,wdth);
 float***  SquWin=fmatrix_allocate_3d(4,SzW,SzW);
 float***  ImgColorSpace=fmatrix_allocate_3d(3,lgth,wdth);
 int**     PtsTab=imatrix_allocate_2d(lgth*wdth,NB_PARAM);
 int*      TabLabel=imatrix_allocate_1d(NB_PARAM);
 int*      VctLabel=imatrix_allocate_1d(lgth*wdth);  

 //Presentation
 printf("\n   >>> SegmentationHisto-COLOR-Kmean-Gradient");
 printf("[NbCl:%d][Div:%d][Ws:%d][Col:%d][Par:%d]",NbClass,div,SzW,bascol,NB_PARAM); 
 if (bascol==0)  printf(" >RGB");
 if (bascol==1)  printf(" >HSV");
 if (bascol==2)  printf(" >YIQ");
 if (bascol==3)  printf(" >XYZ");
 if (bascol==4)  printf(" >LAB");
 if (bascol==5)  printf(" >LUV");
 if (bascol==6)  printf(" >I1I2I3");
 if (bascol==7)  printf(" >H1H2H3");
 if (bascol==8)  printf(" >YCbCr");
 if (bascol==9)  printf(" >TSL");
 if (bascol==10) printf(" >HSL"); 
 if (bascol==11) printf(" >P1P2"); 
 fflush(stdout);
 

 //-------------------------------------------------------------------------
 //Conversion
 //-------------------------------------------------------------------------
 if (bascol==0)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { ImgColorSpace[0][i][j]=img[0][i][j];
      ImgColorSpace[1][i][j]=img[1][i][j];
      ImgColorSpace[2][i][j]=img[2][i][j]; }

 if (bascol==1)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToHSV(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3); 
      ImgColorSpace[0][i][j]=(col1/360.0)*255.0;
      ImgColorSpace[1][i][j]=col2*255.0;
      ImgColorSpace[2][i][j]=col3; }

 if (bascol==2)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToYIQ(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3); 
      ImgColorSpace[0][i][j]=col1*255.0;
      ImgColorSpace[1][i][j]=((col2+0.55)/1.10)*255.0;
      ImgColorSpace[2][i][j]=((col3+0.4)/0.8)*255.0; }

 if (bascol==3)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToXYZ(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1;
      ImgColorSpace[1][i][j]=col2;
      ImgColorSpace[2][i][j]=col3; }

 if (bascol==4)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToLAB(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1*2.55;
      ImgColorSpace[1][i][j]=((col2+128)/271.0)*255.0;
      ImgColorSpace[2][i][j]=((col3+258)/495.0)*255.0; }

 if (bascol==5)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   {  RGBToLUV(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=((col1+16)/250.0)*255.0;
      ImgColorSpace[1][i][j]=((col2+60)/205.0)*255.0;
      ImgColorSpace[2][i][j]=((col3+130)/247.0)*255.0; }

 if (bascol==6)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToI1I2I3(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1;
      ImgColorSpace[1][i][j]=((col2+255)/2.0);
      ImgColorSpace[2][i][j]=((col3+255)/2.0);  }

 if (bascol==7)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToH1H2H3(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1/2.0; 
      ImgColorSpace[1][i][j]=((col2+255)/2.0); 
      ImgColorSpace[2][i][j]=((col3+255)/2.0); }

 if (bascol==8)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToYCbCr(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1; 
      ImgColorSpace[1][i][j]=col2+127.5; 
      ImgColorSpace[2][i][j]=col3+127.5; }

 if (bascol==9)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToTSL(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1*255;
      ImgColorSpace[1][i][j]=255*col2/1.265; 
      ImgColorSpace[2][i][j]=col3*255;  }

 if (bascol==10)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToHSL(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=255*col1/3.142;  
      ImgColorSpace[1][i][j]=col2*254;
      ImgColorSpace[2][i][j]=col3*255; }

 if (bascol==11)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToP1P2(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=(col1+0.707)*255.0/1.414; 
      ImgColorSpace[1][i][j]=(col2+0.408)*255.0/1.224; 
      ImgColorSpace[2][i][j]=0.0; }


 //Debug
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   { if (ImgColorSpace[0][i][j]>255)  ImgColorSpace[0][i][j]=255.0;
     if (ImgColorSpace[1][i][j]>255)  ImgColorSpace[1][i][j]=255.0;
     if (ImgColorSpace[2][i][j]>255)  ImgColorSpace[2][i][j]=255.0;
     if (ImgColorSpace[0][i][j]<0)    ImgColorSpace[0][i][j]=0.0;
     if (ImgColorSpace[1][i][j]<0)    ImgColorSpace[1][i][j]=0.0;
     if (ImgColorSpace[2][i][j]<0)    ImgColorSpace[2][i][j]=0.0; }
 //-------------------------------------------------------------------------- 


 //Init. Matrix   
 for(k=0;k<NB_PARAM;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatxText[k][i][j]=0;
 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     MatxNB[i][j]=(0.33*ImgColorSpace[0][i][j])+(0.33*ImgColorSpace[1][i][j])+(0.33*ImgColorSpace[2][i][j]);

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { MatxHor[i][j]=0.0;
      MatxVer[i][j]=0.0;
      MatxDgd[i][j]=0.0; 
      MatxDgg[i][j]=0.0; }

  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++) MatxHor[i][j]=fabs(MatxNB[i][j-1]-MatxNB[i][j+1]);
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++) MatxVer[i][j]=fabs(MatxNB[i-1][j]-MatxNB[i+1][j]);
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++) MatxDgd[i][j]=fabs(MatxNB[i-1][j-1]-MatxNB[i+1][j+1]);
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++) MatxDgg[i][j]=fabs(MatxNB[i-1][j+1]-MatxNB[i+1][j-1]);

   //------------------------------------
   //--- FEATURES GRAD HISTO ------------
   //------------------------------------
   nbpts=0;
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
        {
         for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
            { posr=i-(SzW/2)+k;
              posc=j-(SzW/2)+l;

              if (posr<0)           posr+=lgth;
              if (posr>(lgth-1))    posr-=lgth;  
              if (posc<0)           posc+=wdth;
              if (posc>(wdth-1))    posc-=wdth;

              SquWin[0][k][l]=MatxHor[posr][posc]; 
              SquWin[1][k][l]=MatxVer[posr][posc];        
              SquWin[2][k][l]=MatxDgd[posr][posc];       
              SquWin[3][k][l]=MatxDgg[posr][posc]; }

              for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
	        { lab=(int)(SquWin[0][k][l]+0.5);
                  if (lab>(NB_GRADBINS-1)) { lab=(NB_GRADBINS-1);  }
                  MatxText[(int)(lab)][i][j]++; }

              for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
	        { lab=(int)(SquWin[1][k][l]+0.5);
                  if (lab>(NB_GRADBINS-1)) { lab=(NB_GRADBINS-1);  } 
                  MatxText[NB_GRADBINS+(int)(lab)][i][j]++; }

              for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
	        { lab=(int)(SquWin[2][k][l]+0.5);
                  if (lab>(NB_GRADBINS-1)) { lab=(NB_GRADBINS-1);  } 
                  MatxText[(2*NB_GRADBINS)+(int)(lab)][i][j]++; }

              for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
	        { lab=(int)(SquWin[3][k][l]+0.5);
                  if (lab>(NB_GRADBINS-1)) { lab=(NB_GRADBINS-1);  } 
                  MatxText[(3*NB_GRADBINS)+(int)(lab)][i][j]++; }

	for(k=0;k<NB_PARAM;k++)  PtsTab[nbpts][k]=MatxText[k][i][j];

        nbpts++;   

        }//-End-Features-Grad-Histo-------- 

 //K-Mean    
 KmeanFast(PtsTab,NbClass,(lgth*wdth),NB_PARAM,VctLabel,Seed,1);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  matout[i][j]=VctLabel[(i*wdth)+j];    

 //Liberation Memoire
 if (MatxText)       free_imatrix_3d(MatxText,NB_PARAM); 
 if (MatxNB)         free_fmatrix_2d(MatxNB);
 if (MatxHor)        free_fmatrix_2d(MatxHor);
 if (MatxVer)        free_fmatrix_2d(MatxVer);
 if (MatxDgd)        free_fmatrix_2d(MatxDgd);
 if (MatxDgg)        free_fmatrix_2d(MatxDgg); 
 if (SquWin)         free_fmatrix_3d(SquWin,3);
 if (ImgColorSpace)  free_fmatrix_3d(ImgColorSpace,3);
 if (PtsTab)         free_imatrix_2d(PtsTab);
 if (TabLabel)       free_imatrix_1d(TabLabel);
 if (VctLabel)       free_imatrix_1d(VctLabel);
}

//----------------
//  FUSION -------
//----------------
//----------------------------------------------------------
// Paint        
//----------------------------------------------------------
void Paint(float** mat,float** mattmp,int row,int col,int lgth,int wdth,int lab)
{
   if ((mattmp[row][col]==0)&&(mat[row][col]==lab))
    { 
     mattmp[row][col]=-1;
     
     if ((col+1)<=(wdth-1))   Paint(mat,mattmp,row,col+1,lgth,wdth,lab);
     if ((col-1)>=0)          Paint(mat,mattmp,row,col-1,lgth,wdth,lab);
     if ((row+1)<=(lgth-1))   Paint(mat,mattmp,row+1,col,lgth,wdth,lab);
     if ((row-1)>=0)          Paint(mat,mattmp,row-1,col,lgth,wdth,lab); 
     }

 else return;
}

//----------------------------------------------------------
// Paint        
//----------------------------------------------------------
void Paint(float** mat,int** mattmp,int row,int col,int lgth,int wdth,int lab)
{
 if ((mattmp[row][col]==0)&&(mat[row][col]==lab))
    { 
     mattmp[row][col]=-1;

     if ((col+1)<=(wdth-1))  Paint(mat,mattmp,row,col+1,lgth,wdth,lab);
     if ((col-1)>=0)         Paint(mat,mattmp,row,col-1,lgth,wdth,lab);
     if ((row+1)<=(lgth-1))  Paint(mat,mattmp,row+1,col,lgth,wdth,lab);
     if ((row-1)>=0)         Paint(mat,mattmp,row-1,col,lgth,wdth,lab); 
     }

 else return;
}

//----------------------------------------------------------
// Convert <ClassRegion>              
//----------------------------------------------------------
void ConvertClassRegion(float** mat,int lgth,int wdth)
{
 int i,j,k,l,m;
 int label;
 float coul;
 int nb;
 int cpt;
 
  //Allocation 
  int** mattmp=imatrix_allocate_2d(lgth,wdth);
  int*  TabGrey=imatrix_allocate_1d(256);
  
  //Init 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=(int)mat[i][j];
  for(i=0;i<256;i++)  TabGrey[i]=0;

  //Check
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     if ((mat[i][j]>=0)&&(mat[i][j]<256)) TabGrey[int(mat[i][j])]++;

   for(nb=0,i=0;i<256;i++)  if (TabGrey[i]) nb++;
   printf("\n >> NbClasses [%d]",nb);
   fflush(stdout);
   for(i=0;i<256;i++)  TabGrey[i]=0; 

  //Boucle
  //-------
  cpt=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (mattmp[i][j]==0)
        {
	 label=(int)mat[i][j];
         //printf("[^^^^%d-%d(%d)^^^^]",i,j,(int)label);

         Paint(mat,mattmp,i,j,lgth,wdth,label);

         do 
           { coul=(int)(randomize()*255); }
         while (TabGrey[(int)coul]);

         TabGrey[(int)coul]=1;
         ++cpt;
         
         if (cpt>=255)
	    { for(m=0;m<256;m++)  TabGrey[m]=0;
              cpt=0; printf("*Regions debordent*"); }        

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
	   if (mattmp[k][l]==-1) mat[k][l]=(int)coul;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
	   if (mattmp[k][l]==-1) mattmp[k][l]=-2;
        }
 
   //Compte Regions
   for(i=0;i<256;i++)  TabGrey[i]=0;
      
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) TabGrey[int(mat[i][j])]++;

   for(nb=0,i=0;i<256;i++)  if (TabGrey[i]) nb++;
       printf(" :: NbRegions [%d]",nb);
   fflush(stdout);

 //Liberation 
 free_imatrix_2d(mattmp); 
 free_imatrix_1d(TabGrey); 
}

//----------------------------------------------------------
//  ComputeNumberRegions          
//----------------------------------------------------------
int ComputeNumberRegions(float** mat,int lgth,int wdth)
{
 int i,j,k,l;
 int label;
 int cpt;
 
  //Allocation 
  int** mattmp=imatrix_allocate_2d(lgth,wdth);
  float** matx=fmatrix_allocate_2d(lgth,wdth);
  
  //Init 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matx[i][j]=(int)mat[i][j];

  //Boucle
  //-------
  cpt=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (mattmp[i][j]==0)
        {
	 label=(int)matx[i][j];
         Paint(matx,mattmp,i,j,lgth,wdth,label);          
         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) matx[k][l]=cpt;
         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;
         cpt++;
        }
 
   //Nombre Regions
   printf("\n >> NbRegions [%d]",cpt);
   fflush(stdout);

 //Liberation 
 free_imatrix_2d(mattmp); 
 free_fmatrix_2d(matx);

 //Retour
 return cpt; 
}


//--------------------------------
//--------------------------------
//---CLEAN------------------------
//--------------------------------
//----------------------------------------------------------
// FuseRegions
//
// < Petite regions inferieur taille sz fusione avec
//    classe majoritaire l entourant >
//              
//----------------------------------------------------------
int FuseSmallRegions(float** mat,int lgth,int wdth,int* nbreg,int sz)
{
 int i,j,k,l,m,n,t;
 float maxim;
 int  labfuse;
 int cpt;
 int initsize;
 int size_min;
 int nbregion_prec;
 int nbregion_init;
 int NbChgt;

 //Allocation 
 float**  mattmp=fmatrix_allocate_2d(lgth,wdth);
 float*   claslb=fmatrix_allocate_1d(256);

 //Init 
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=(int)mat[i][j]; 
 NbChgt=0;

 //Init
 size_min=0;
 nbregion_prec=0;
 cpt=10;
 printf("\n  FuseSmallRegions[%d]",sz);
 printf("\n  Regions>");

 //BOUCLE
 //========================================================================
 for(t=0;((t<12)&&(size_min<sz)&&(nbregion_prec!=cpt));t++)
   {

    //Init 
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;

       //Boucle
       //-------------------------------------
        for(cpt=0,i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mattmp[i][j]==0)
              {
	       initsize=0;
               Paint(mat,mattmp,i,j,lgth,wdth,(int)mat[i][j]);
               ++cpt;
               for(k=0;k<256;k++)  claslb[k]=0;

               //RegionsVoisines
               for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)  
	            { initsize++;
                      for(m=-1;m<2;m++) for(n=-1;n<2;n++) 
		        if (((k+m)>=0)&&((k+m)<lgth)&&((l+n)>=0)&&((l+n)<wdth))
		            if (mat[k+m][l+n]<256) claslb[(int)mat[k+m][l+n]]++;  }

               claslb[(int)mat[i][j]]=0;

               //ClasseVoisineMajoritaire
               labfuse=0;
               maxim=0;
               for(k=0;k<256;k++) if (claslb[k]>maxim) { maxim=claslb[k]; labfuse=k; };

               //SiCondition=>Fusion
               if (initsize<=sz)
	          { for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)
                    mat[k][l]=labfuse; 
                    NbChgt++; }

               for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;
	      }//---------------------------

     nbregion_init=cpt;
     size_min=lgth*wdth;
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;

     nbregion_prec=cpt;
     for(cpt=0,i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mattmp[i][j]==0)
        {
         initsize=0;
         Paint(mat,mattmp,i,j,lgth,wdth,(int)mat[i][j]);
         ++cpt;
 
         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)  initsize++;

         if (initsize<size_min) size_min=initsize; 

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;  
       }

      printf("(>%d)",cpt);
      (*nbreg)=cpt;
      fflush(stdout);
   }//=====================================================================
 
 //Liberation 
 if (mattmp)  free_fmatrix_2d(mattmp); 
 if (claslb)  free_fmatrix_1d(claslb); 

 //Retour
 printf("   |NbChgt >[%d]",NbChgt);
 return NbChgt;
}

//----------------------------------------------------------
// MedianFilter
//----------------------------------------------------------
// MedianFilter
//      voisinage SzN*SzN
//----------------------------------------------------------
void MedianFilter(float** mt,int lgth,int wdth,int SzN) 
{
 int i,j,k,l,m;
 int nb;
 float tmp;

 float** mat_tmp;
 float* vect;

 //reservation memoire
 mat_tmp=fmatrix_allocate_2d(lgth,wdth);
 vect=fmatrix_allocate_1d(SzN*SzN);

 //recopie matrice
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat_tmp[i][j]=mt[i][j];

 //Filtre median
 for(i=(SzN/2);i<(lgth-(SzN/2));i++) for(j=(SzN/2);j<(wdth-(SzN/2));j++)
   {
    nb=0;
    for(k=-(SzN/2);k<=(SzN/2);k++) for(l=-(SzN/2);l<=(SzN/2);l++)  if (!((k==0)&&(l==0)))
        vect[nb++]=mat_tmp[i+k][j+l];

    for(l=0;l<((SzN*SzN)-1);l++) for(m=0;m<((SzN*SzN)-1);m++)
       if (vect[m]>vect[m+1]) 
          { tmp=vect[m];
            vect[m]=vect[m+1];
            vect[m+1]=tmp; } 

   mt[i][j]=vect[((SzN*SzN)/2)]; 
   }

 //liberation memoire
 free_fmatrix_2d(mat_tmp);
 free(vect); 
}


//---------------------
//---VISU CONTOUR------
//---------------------
//----------------------------------------------------------*/
// AddContour                               
//----------------------------------------------------------*/
void AddContourImg(float** seg,int*** img,int lgth,int wdth,int gross) 
{
 int i,j,k,l;
 float tmp;
 int dep;

 //Init
 dep=(int)(gross/2);

 //AllocationMemoire
 float** mat_tmp=fmatrix_allocate_2d(lgth,wdth);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat_tmp[i][j]=255.0;

 //Gradient
 for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
   { tmp=sqrt(CARRE(seg[i+1][j]-seg[i][j])+CARRE(seg[i][j+1]-seg[i][j]));
     if (tmp>0) mat_tmp[i][j]=0.0; }

 //Boucle
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat_tmp[i][j]==0.0)
      {
       for(k=-dep;k<=dep;k++) for(l=-dep;l<=dep;l++)
	 if (((i+k)>0)&&((i+k)<lgth)&&((j+l)>0)&&((j+l)<wdth))
	  { img[0][i+k][j+l]=0; 
            img[1][i+k][j+l]=0; 
            img[2][i+k][j+l]=0; }
      }    

 //liberation memoire
 free_fmatrix_2d(mat_tmp); 
}


//--------------------------------
//--------------------------------
//---GESTION----------------------
//--------------------------------
//----------------------------------------------------------
// Multiresolution
//----------------------------------------------------------
void Multires(int*** mat,int szbl,int lgth,int wdth,int*** sol)
{
 int i,j,k,l,m;
 int nb;
 float sum_pix;

 //Boucle
 for(m=0;m<3;m++)
 for(i=0;i<(int)(lgth/szbl);i++) for(j=0;j<(int)(wdth/szbl);j++)
    {
     sum_pix=0.0;
     nb=0;
     for(k=i*szbl;k<(i*szbl+szbl);k++) for(l=j*szbl;l<(j*szbl+szbl);l++)
	  { if ((k<lgth)&&(l<wdth))
	       { sum_pix+=mat[m][k][l];   nb++; } }

             sum_pix/=(CARRE((float)(szbl)));
             sol[m][i][j]=(int)sum_pix;
    }
}

//----------------------------------------------------------
// Duplication
//----------------------------------------------------------
void Duplication(float** MatIn,float** MatOut,int scale,int lgth,int wdth)
{
 int i,j;

 //>Decimation Inverse
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
  if ((int(i/scale)<(lgth/scale))&&(int(j/scale)<(wdth/scale))) 
     MatOut[i][j]=MatIn[(int)(i/scale)][(int)(j/scale)];
} 


//----------------------------------------------------------
// ConvertClassRegionInf
//----------------------------------------------------------
void ConvertClassRegionInf(float** MatIn,int** MatOut,int lgth,int wdth)
{
 int i,j,k,l;
 int label;
 int cpt;

  //Allocation
  int** mattmp=imatrix_allocate_2d(lgth,wdth);

  //Init
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     { mattmp[i][j]=0;
       MatOut[i][j]=0; }
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatIn[i][j]=(int)MatIn[i][j];

  //Boucle
  //-------
  cpt=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (mattmp[i][j]==0)
        {
         label=(int)MatIn[i][j];
         Paint(MatIn,mattmp,i,j,lgth,wdth,label);

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
           if (mattmp[k][l]==-1) MatOut[k][l]=cpt;

         cpt++;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
           if (mattmp[k][l]==-1) mattmp[k][l]=-2;
        }

  //Compte Regions
  //printf(" [NbReg=%d]",cpt);
  //fflush(stdout);

 //Liberation
 free_imatrix_2d(mattmp);
}

//--------------------------------
//--------------------------------
//---FUSION MODEL-----------------
//--------------------------------



//----------------------------------------------------------
// NumberRegionMax
//----------------------------------------------------------
int NumberRegionMax(int*** TabSeg,int lgth,int wdth,int NbSegs)
{
 int i,j,k;
 int MaxRegions;
 int IndxSegMaxReg;
 
 MaxRegions=0;
 IndxSegMaxReg=-1;
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 if (TabSeg[k][i][j]>MaxRegions) { MaxRegions=TabSeg[k][i][j]; IndxSegMaxReg=k; }
 
 MaxRegions++;
 printf("\n  >> [%d:::MaxNumberRegions=%d]",IndxSegMaxReg,MaxRegions);

 return MaxRegions;
}

//----------------------------------------------------------
//  ComputeMatProbVoI  :: Seg_k=MatIn  
//                     :: P_k,k' ou  Card[C_k Inter C_k']
//
//----------------------------------------------------------
void ComputeMatProbVoI(int*** TabMat,int** MatIn,int lgth,int wdth,int NbSegs,int*** MatProbVoI,int NbRegMax)
{
 int i,j,k,l,m;

 //Init
 for(k=0;k<NbSegs;k++) for(l=0;l<NbRegMax;l++) for(m=0;m<NbRegMax;m++) 
 MatProbVoI[k][l][m]=0;

 //Compute
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 MatProbVoI[k][MatIn[i][j]][TabMat[k][i][j]]++; 
}

//----------------------------------------------------------
//  ComputePropClustKprime :: P_k' ou Card(C_k')
//
//----------------------------------------------------------
void ComputePropClustKprime(int*** TabMat,int** PropClust,int lgth,int wdth,int NbSegs,int NbRegMax)
{
 int i,j,k,l;
 
 //Init
 for(k=0;k<NbSegs;k++) for(l=0;l<NbRegMax;l++) PropClust[k][l]=0; 

 //Estimator
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 PropClust[k][TabMat[k][i][j]]++;
}


//----------------------------------------------------------
//  ComputePropClust :: P_k ou Card(C_k)
//
//----------------------------------------------------------
void ComputePropClustK(int* HistReg,int** SegReg,int lgth,int wdth,int NbRegMax)
{
 int i,j,k;

 //LOOP
 for(k=0;k<NbRegMax;k++) HistReg[k]=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  HistReg[SegReg[i][j]]++;
}

//----------------------------------------------------------
// float VariationInformation
//----------------------------------------------------------
float VariationInformation(int** MatReg1,int** MatReg2,int lgth,int wdth)
{
 int i,j,k,l;
 int NbReg1,NbReg2;
 float H_MtRg1,H_MtRg2,I_MtRg1Rg2,VoI;
 float tmp;
 float prop1,prop2;

 //EstimateNbRegMax
 NbReg1=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (MatReg1[i][j]>NbReg1) NbReg1=MatReg1[i][j];
 NbReg1++;
 NbReg2=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (MatReg2[i][j]>NbReg2) NbReg2=MatReg2[i][j];
 NbReg2++;

 //AllocationMemory
 int*  HistMatReg1=imatrix_allocate_1d(NbReg1);
 int*  HistMatReg2=imatrix_allocate_1d(NbReg2);
 int** HistMatRegJoin=imatrix_allocate_2d(NbReg1,NbReg2);

 //ComputeHistoReg
 for(k=0;k<NbReg1;k++) HistMatReg1[k]=0; 
 for(k=0;k<NbReg2;k++) HistMatReg2[k]=0; 

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    {  HistMatReg1[MatReg1[i][j]]++;
       HistMatReg2[MatReg2[i][j]]++; }

 //Compute<Entropy>H(MatReg1)_H(MatReg2)
 H_MtRg1=0.0;
 for(k=0;k<NbReg1;k++)
   { tmp=((float)HistMatReg1[k]/(float)(wdth*lgth)); 
     if(tmp) H_MtRg1-=tmp*log2(tmp); } 
 //printf("[Entropy(Rg1)=%.3f]",H_MtRg1);

 H_MtRg2=0.0;
 for(k=0;k<NbReg2;k++)
   { tmp=((float)HistMatReg2[k]/(float)(wdth*lgth)); 
     if (tmp) H_MtRg2-=tmp*log2(tmp); } 
 //printf("[Entropy(Rg2)=%.3f]",H_MtRg2);

 //Compute JointEntropy
 for(k=0;k<NbReg1;k++) for(l=0;l<NbReg2;l++) HistMatRegJoin[k][l]=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) HistMatRegJoin[MatReg1[i][j]][MatReg2[i][j]]++; 

 I_MtRg1Rg2=0.0;
 for(k=0;k<NbReg1;k++) for(l=0;l<NbReg2;l++) 
   { tmp=(((float)HistMatRegJoin[k][l])/(wdth*lgth));
     prop1=(float)HistMatReg1[k]/(wdth*lgth);
     prop2=(float)HistMatReg2[l]/(wdth*lgth);
     if (tmp) I_MtRg1Rg2+=tmp*log2(tmp/(prop1*prop2)); }

 //Compute VariationInformation
 VoI=H_MtRg1+H_MtRg2-(2*I_MtRg1Rg2);
 //printf("[VoI=%.3f]<%.3f?",H_MtRg1,log2(wdth*lgth));
 
  //FreeMemory
 if (HistMatReg1) free_imatrix_1d(HistMatReg1);
 if (HistMatReg2) free_imatrix_1d(HistMatReg2);
 if (HistMatRegJoin) free_imatrix_2d(HistMatRegJoin);

 //Return
 return VoI;
}

//----------------------------------------------------------
// float MoyVariationInformation
//----------------------------------------------------------
float MoyVariationInformation(int** MatReg,int*** TabMatReg,int lgth,int wdth,int nb,int info)
{
 int k;
 float VoI,MoyVoI;
 int cpt;

 //LOOP
 MoyVoI=0.0;
 cpt=0;
 for(k=0;k<nb;k++) 
    { VoI=VariationInformation(MatReg,TabMatReg[k],lgth,wdth);
      MoyVoI+=VoI;
      cpt++;
      if (info) printf("[%d:%.1f] ",k,VoI); }

 MoyVoI/=(float)(cpt);
 if (info) printf("\n [MoyVoI=%.3f]",MoyVoI);

 //Retour
 return MoyVoI;
}


//----------------------------------------------------------
// int Select
//----------------------------------------------------------
int SelectSegMap(int*** TabMatReg,int lgth,int wdth,int nb,float* TabVoI)
{
 int k;
 float MinMoyVoI,VoIMoy;
 int IndxMinMoyVoI;

 //>MemoryAllocation
 int** MatInt=imatrix_allocate_2d(lgth,wdth);

 //LOOP
 MinMoyVoI=10000;
 IndxMinMoyVoI=-1;
 for(k=0;k<nb;k++)
   { //printf("\n  [nb::%d]",k);
     //fflush(stdout);
     CopyMat(MatInt,TabMatReg[k],lgth,wdth);
     VoIMoy=MoyVariationInformation(MatInt,TabMatReg,lgth,wdth,nb,0);
     //VoIMoy=MoyDistPRI(MatInt,TabMatReg,lgth,wdth,nb,0);
     //VoIMoy=MoyDistFMeasure(MatInt,TabMatReg,lgth,wdth,nb,0);
     TabVoI[k]=VoIMoy;
     if (VoIMoy<MinMoyVoI) { MinMoyVoI=VoIMoy; IndxMinMoyVoI=k; } 
   }

 //FreeMemory 
 if (MatInt) free_imatrix_2d(MatInt);

 //Info
 printf("\n  >> SelectSegMap[%d::VoIMin=%.3f]",IndxMinMoyVoI,MinMoyVoI);

 //Return
 return IndxMinMoyVoI;
}

//----------------------------------------------------------
// int Classify
//----------------------------------------------------------
void Classify(int*** TabMatReg,int lgth,int wdth,int nb,float* TabVoI)
{
 int k;

 //>MemoryAllocation
 int***  TabSeg=imatrix_allocate_3d(nb,lgth,wdth);
 float** Tab2DVoI=fmatrix_allocate_2d(nb,2);

 //>Init
 for(k=0;k<nb;k++) { Tab2DVoI[k][0]=TabVoI[k]; Tab2DVoI[k][1]=k; }
 sort(Tab2DVoI,0,nb,2);

 //>Info
 for(k=0;k<nb;k++) printf("\n  [%d...%.0f::%.2f]",k,Tab2DVoI[k][1],Tab2DVoI[k][0]);
 
 //>OutputRes
 for(k=0;k<nb;k++) CopyMat(TabSeg[k],TabMatReg[(int)(Tab2DVoI[k][1])],lgth,wdth);
 for(k=0;k<nb;k++) CopyMat(TabMatReg[k],TabSeg[k],lgth,wdth);

 //FreeMemory 
 if (TabSeg)   free_imatrix_3d(TabSeg,nb);
 if (Tab2DVoI) free_fmatrix_2d(Tab2DVoI);
}

//----------------------------------------------------------------
//  quickSort
//  ---------     Arr[l][c]   :: Arr[l][0] a classer
//                            :: l \in [beg::end]
//                            :: c \in [0::Nb]
//----------------------------------------------------------------
void sort(float** arr,int beg,int end,int Nb)
{
 int k;

 //>Sort
 if (end>beg+1)
  {
    float piv=arr[beg][0];
    int l=beg+1,r=end;
    while (l<r)
    {
      if (arr[l][0]<=piv) l++;  
      else { r--; for(k=0;k<Nb;k++) swap(&arr[l][k],&arr[r][k]); }
    }
    l--; for(k=0;k<Nb;k++) swap(&arr[l][k],&arr[beg][k]);
    sort(arr,beg,l,Nb);
    sort(arr,r,end,Nb);
  }
} 

void swap(float* a,float* b)
{
  float t=*a; *a=*b; *b=t;
}


//----------------------
//----------------------
//----------------------
//----------------------------------------------------------
// FillVectNeighb
//----------------------------------------------------------
void FillVectNeighb(int** Seg,int lgth,int wdth,int* Vct,int SzW,int row,int col)
{
 int k,l;
 int SzWdiv2=SzW/2;
 int posr,posc;
 int nb;

 //Fill
 nb=0;
 for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) Vct[(k*SzW)+l]=-1;
 for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { 
          posr=row-(SzWdiv2)+k;
          posc=col-(SzWdiv2)+l;
          if (posr<0)         posr+=lgth;
          if (posr>(lgth-1))  posr-=lgth; 
          if (posc<0)         posc+=wdth;
          if (posc>(wdth-1))  posc-=wdth;

          if ((int)(Seg[row][col])!=(int)(Seg[posr][posc]))
	     { Vct[nb]=(int)(Seg[posr][posc]);
               nb++; }
	}
}

//----------------------------------------------------------
// GiveRandomVal
//----------------------------------------------------------
int GiveRandomLab(int* Vct,int LgthVct)
{
 int k;
 int nb,index;
 
 //FindNb&RandomVal
 for(k=0,nb=0;k<LgthVct;k++) 
   { if ((int)Vct[k]!=-1) nb=k; 
      else break; }

 index=(int)((float)nb*randomize());
 return Vct[index];
}

//-----------------------------------------------------------------------
// Compute Local NRJ VoI
// ---------------------
//
// At Pixel [row][col]  i.e. MatReg[row][col]  On choisit <lab1>     
//
//         using >> MatProbVoI[NbSegs][k][k']    (P_k_k') (k<NbRegionMax)
//               >> PropClust[NbSegs][k']        (P_k')
//               >> HistMatReg[k]                (P_k)
//               >> TabMatReg[NbSegs][row][col]  Set Of Segmnetations To Be Fused
//
//-----------------------------------------------------------------------
float ComputeLocNrjVoI(int** MatReg,int* HistMatReg,int row,int col,int Lab1,int lgth,int wdth,\
int*** TabMatReg,int Lab2,int*** MatProbVoI,int** PropClust,int NbSegs)
{ 
 int n,p;
 int NbBinLab1,NbBinLab2;
 double Entropy;
 double CrossEntropy;
 double VoI;
 double tmp1,tmp2;
 double NbPix;
 double nLab1,nLab2,nk_prime;

 NbPix=(wdth*lgth);

 //================
 //Entropy : H(C_k)
 //================
 NbBinLab1=HistMatReg[Lab1];
 NbBinLab2=HistMatReg[Lab2];
 
 //[Lab2-->Lab1]
 if (MatReg[row][col]!=Lab1)
    { NbBinLab1++;
      NbBinLab2--; }

 Entropy=0.0;
   { tmp1=(float)NbBinLab1/(float)(NbPix);
     tmp2=(float)NbBinLab2/(float)(NbPix);
     if (tmp1) Entropy-=(tmp1*log2(tmp1));
     if (tmp2) Entropy-=(tmp2*log2(tmp2)); }

 //============================
 //Cross-Entropy : I(C_k,C_k')
 //============================
 CrossEntropy=0.0;
 nLab1=nLab2=0;
 for(n=0;n<NbSegs;n++) 
   {
    p=TabMatReg[n][row][col];
    nk_prime=NbPix/PropClust[n][p];

    if (MatReg[row][col]!=Lab1) //[Lab2-->Lab1]
       { tmp1=(float)(MatProbVoI[n][Lab1][p]+1)/NbPix;
         tmp2=(float)(MatProbVoI[n][Lab2][p]-1)/NbPix;

         nLab1=NbPix/(HistMatReg[Lab1]+1);
         nLab2=NbPix/(HistMatReg[Lab2]-1); }

    else //[Lab1 & Lab2 <NoChange>]
	{ tmp1=(float)(MatProbVoI[n][Lab1][p])/NbPix;
          tmp2=(float)(MatProbVoI[n][Lab2][p])/NbPix;

          nLab1=NbPix/HistMatReg[Lab1];
          nLab2=NbPix/HistMatReg[Lab2]; }
  
          if (tmp1<0) tmp1=0;
          if (tmp2<0) tmp2=0;
	  if (tmp1) CrossEntropy+=(tmp1*log2(tmp1*nLab1*nk_prime));
          if (tmp2) CrossEntropy+=(tmp2*log2(tmp2*nLab2*nk_prime)); 
   }

 //====================================
 //VariationInformation : VI(C_k,C_k')
 //====================================
 VoI=(NbSegs*Entropy)-(2.0*CrossEntropy);

 //Return
 return VoI;
}

//----------------------------------------------------------
// ICM_VoILoc
//----------------------------------------------------------   
void ICM_VoILoc(int** MatRegIn,int** MatRegOut,int*** TabMatReg,int lgth,int wdth,int NbSegs,int NbIter)
{
 int i,j,k; 
 int n,p;
 int NbRegMaxSegIn,NbRegions,NbRegMaxTabSeg;
 int Lab1,Lab2;
 int nbchgt;
 float VoI;
 float DeltaNrj,nrj1,nrj2;
 float VoI_old;

 //EstimationParam
 NbRegMaxSegIn=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (MatRegIn[i][j]>NbRegMaxSegIn) NbRegMaxSegIn=MatRegIn[i][j];
 NbRegMaxSegIn++;
 NbRegions=NbRegMaxSegIn;
 NbRegMaxTabSeg=NumberRegionMax(TabMatReg,lgth,wdth,NbSegs);
 
 //AllocationMemory
 int**  SegTmp1=imatrix_allocate_2d(lgth,wdth);
 int**  SegTmp2=imatrix_allocate_2d(lgth,wdth);
 int*   VctNeighb=imatrix_allocate_1d(SIZENEIGHB*SIZENEIGHB);
 int*   HistRegSeg=imatrix_allocate_1d(NbRegMaxSegIn);
 int*** MatProbVoI=imatrix_allocate_3d(NbSegs,NbRegMaxTabSeg,NbRegMaxTabSeg);
 int**  PropClust=imatrix_allocate_2d(NbSegs,NbRegMaxTabSeg);

 //Compute [P_k] [P_k_k'] [P_k'] 
 ComputePropClustKprime(TabMatReg,PropClust,lgth,wdth,NbSegs,NbRegMaxTabSeg);
 ComputePropClustK(HistRegSeg,MatRegIn,lgth,wdth,NbRegMaxSegIn);  
 ComputeMatProbVoI(TabMatReg,MatRegIn,lgth,wdth,NbSegs,MatProbVoI,NbRegMaxTabSeg);
 
 //>Init
 CopyMat(SegTmp1,MatRegIn,lgth,wdth);
 VoI=MoyVariationInformation(MatRegIn,TabMatReg,lgth,wdth,NbSegs,0);
 printf("\n\n   > ICM_VoILoc::[NbIter=%d][NbRegions=%d][NbSegs=%d][VoI=%.5f]",NbIter,NbRegions,NbSegs,VoI); 
 fflush(stdout);

  //====================================================================
  //ICM_VoILoc    [MatRegIn >>> MatRegOut]
  //====================================================================
  for(k=0;k<NbIter;k++)
     {
      if (!(k%1)) 
      CopyMat(SegTmp2,SegTmp1,lgth,wdth);

      //MiseAJour[P_k_k'::P_k'::P_k]    
      ComputePropClustK(HistRegSeg,SegTmp1,lgth,wdth,NbRegMaxSegIn);
      ComputePropClustKprime(TabMatReg,PropClust,lgth,wdth,NbSegs,NbRegMaxTabSeg);
      ComputeMatProbVoI(TabMatReg,SegTmp1,lgth,wdth,NbSegs,MatProbVoI,NbRegMaxTabSeg);

      //-----------------------------------------------------------
      // Loop Img > Loop Pixels
      //------------------------------------------------------------
      for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
            {
               //Gibbs Sampling Record
               Lab1=SegTmp1[i][j];

               FillVectNeighb(SegTmp1,lgth,wdth,VctNeighb,SIZENEIGHB,i,j);
               Lab2=GiveRandomLab(VctNeighb,SIZENEIGHB*SIZENEIGHB);

               //4ConnexityRequestedElseContinue 
	       if (!((Lab2==SegTmp1[i+1][j])||(Lab2==SegTmp1[i-1][j])||(Lab2==SegTmp1[i][j-1])||(Lab2==SegTmp1[i][j+1])))
	       continue;            

               //NoDifferentNeighborsElseContinue
	       if (Lab2==-1)
               continue;
 
	       nrj1=ComputeLocNrjVoI(SegTmp1,HistRegSeg,i,j,Lab1,lgth,wdth,TabMatReg,Lab2,MatProbVoI,PropClust,NbSegs);
               nrj2=ComputeLocNrjVoI(SegTmp1,HistRegSeg,i,j,Lab2,lgth,wdth,TabMatReg,Lab1,MatProbVoI,PropClust,NbSegs);  
               DeltaNrj=nrj2-nrj1;


               //Lab1->Lab2 At[row=i;col=j]
               if (DeltaNrj<0) 
		 { 
                   SegTmp1[i][j]=Lab2;

                   //RemiseAJour[HistRegSeg][P_k]
                   HistRegSeg[Lab1]--;
                   HistRegSeg[Lab2]++; 
                   if (HistRegSeg[Lab1]<=0) { HistRegSeg[Lab1]=0; printf("*"); }

                   //RemiseAJour[MatProbVoI][P_k_k']
                   for(n=0;n<NbSegs;n++) 
		      { p=TabMatReg[n][i][j]; 
                        MatProbVoI[n][Lab1][p]--; 
                        MatProbVoI[n][Lab2][p]++; }                
                 }
           
             }//End_Loop_Pixel------------------------------------------  

          //>Info
          if (!(k%1))
	    {  VoI_old=VoI;
               VoI=MoyVariationInformation(SegTmp1,TabMatReg,lgth,wdth,NbSegs,0);  
	       if ((k>20)&&(VoI_old<=VoI)) break;  
               nbchgt=DiffMatNb(SegTmp2,SegTmp1,lgth,wdth);
               printf("\n  [%d]>%.5f  [NbChgt=%d]",k,VoI,nbchgt); 
               fflush(stdout); }

         }//End_ICM===========================================================================
  
 //Nrj_finale[ImgRes] 
 CopyMat(MatRegOut,SegTmp1,lgth,wdth);
 VoI=MoyVariationInformation(MatRegOut,TabMatReg,lgth,wdth,NbSegs,0);
 printf("\n   >> [VoI:%.5f]\n",VoI); 
 
 //FreeMemory
 if (SegTmp1)    free_imatrix_2d(SegTmp1); 
 if (SegTmp2)    free_imatrix_2d(SegTmp2); 
 if (HistRegSeg) free_imatrix_1d(HistRegSeg);
 if (VctNeighb)  free_imatrix_1d(VctNeighb);
 if (MatProbVoI) free_imatrix_3d(MatProbVoI,NbSegs);
 if (PropClust)  free_imatrix_2d(PropClust);
}

//---------------------//
// COMPLEXITY ---------//
//---------------------//
//----------------------------------------------------------
// Complexity
//----------------------------------------------------------   
float Complexity(int*** img,int lgth,int wdth,int div,int SzW)
{
 int i,j,k,l;
 int posr,posc;
 int NbParam;
 float divis;
 int lab;
 float nrj;

 //>Record
 NbParam=div*div*div; 
 divis=(256.0/(float)div);   
 
 //AllocMemoire
 float*** SquWin=fmatrix_allocate_3d(3,SzW,SzW);
 float*   MatHisMoy=fmatrix_allocate_1d(NbParam);
 float*** MatHis=fmatrix_allocate_3d(NbParam,lgth,wdth);

  //Initialization
  for(k=0;k<NbParam;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatHis[k][i][j]=0; 

  //-------------------------------------------------------------
  //RecupLocalHistoMoy  [div][SzW] 
  //-------------------------------------------------------------     
  printf("\n\n   [Recup Histos Moy...]");
  fflush(stdout);   
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    {
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { posr=i-(SzW/2)+k;
          posc=j-(SzW/2)+l;

          if (posr<0)           posr+=lgth;
          if (posr>(lgth-1))    posr-=lgth;  
          if (posc<0)           posc+=wdth;
          if (posc>(wdth-1))    posc-=wdth;

          SquWin[0][k][l]=img[0][posr][posc];
          SquWin[1][k][l]=img[1][posr][posc];
          SquWin[2][k][l]=img[2][posr][posc]; }
   
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
	{ lab=((int)(SquWin[0][k][l]/divis))*(div*div);
          lab+=((int)(SquWin[1][k][l]/divis))*(div);  
          lab+=((int)(SquWin[2][k][l]/divis)); 
   
          MatHis[(int)(lab)][i][j]++; 
          MatHisMoy[(int)(lab)]++; }

     for(k=0;k<NbParam;k++) MatHis[k][i][j]/=(SzW*SzW);
    }
  for(k=0;k<NbParam;k++) MatHisMoy[k]/=(lgth*wdth*SzW*SzW);
 //-----------------------------------------------------------

 //---------------------------------------------------
 //Boucle---------------------------------------------
 //---------------------------------------------------
 printf("\n   ComplexityImage ");
 fflush(stdout);
 nrj=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   for(k=0;k<NbParam;k++) nrj+=fabs(MatHis[k][i][j]-MatHisMoy[k]);

 nrj/=(lgth*wdth*2);
 //-------------------------------------------------

  //Liberation Memoire
  if (SquWin)    free_fmatrix_3d(SquWin,3);
  if (MatHis)    free_fmatrix_3d(MatHis,NbParam);
  if (MatHisMoy) free_fmatrix_1d(MatHisMoy);

 //Retour
  return nrj;
}


