//---------------------------------------------------
// module  : f_VOIBFM.cc                       
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "VOIBFM.h"

//------------------------------------------------
// METHODES DE LA CLASSE VOIbfM  ------------------
//------------------------------------------------
//----------------------------------------------------------
// Constructeur de la classe VOIbfM
//----------------------------------------------------------
VOIBFM::VOIBFM(int*** imgt,int lgth,int wdth)           
 {
  int i,j,k;

  //Initialisation
  length=lgth;
  width=wdth;

  //Allocation Memoire Matrice 
  mat_img=imatrix_allocate_3d(3,length,width);
  mat_cnt=imatrix_allocate_3d(3,length,width);
  mat_seg=fmatrix_allocate_2d(length,width);

  //Initialisation
  for(k=0;k<3;k++)
  for(i=0;i<length;i++) for(j=0;j<width;j++) 
    { mat_img[k][i][j]=imgt[k][i][j];     
      mat_cnt[k][i][j]=imgt[k][i][j]; }
 }

//----------------------------------------------------------
// Destructeur de la classe VOIFBM
//----------------------------------------------------------
VOIBFM::~VOIBFM()
{ 
  //Libere Memoire Matrice 
  if (mat_img)    free_imatrix_3d(mat_img,3);
  if (mat_cnt)    free_imatrix_3d(mat_cnt,3);
  if (mat_seg)    free_fmatrix_2d(mat_seg);
}

//----------------------------//
//----------GESTION-----------//
//----------------------------//
//----------------------------------------------------------
// MultipleSegmentations
// ---------------------
//
//----------------------------------------------------------  
void VOIBFM::MultipleSegmentations(float*** TabSeg,int NbSpCl,int NbCl1,int NbCl2)
{
 int k,l,m;
 int nbreg;

 //Presentation
 printf("\n  > MultipleSegmentations NbBin&Grad [NbBins::%d] [Size::%d]",NBINS,SIZE1);
 printf("\n  ----------------------------------------------------------");
 fflush(stdout);

 //-------//
 // COUL  //
 //-------//
 if (NbCl1)
 { printf("\n\n <NbClasses [%d]><COUL>",NbCl1);
   printf("\n ---------------");
   for(k=0;k<NbSpCl;k++) 
     { SegmentationHistoCOLORKmeanFast(mat_img,TabSeg[k],length,width,NbCl1,NBINS,SIZE1,k,k);
       for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; } }

 if (NbCl2)
 { printf("\n\n\n <NbClasses [%d]><COUL>",NbCl2);
   printf("\n ---------------");
   for(k=NbSpCl,l=0;k<(2*NbSpCl);k++,l++) 
     { SegmentationHistoCOLORKmeanFast(mat_img,TabSeg[k],length,width,NbCl2,NBINS,SIZE1,k,l);
       for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; } }


 //-------//
 // NbBin //
 //-------//
 if (NbCl1)
 { printf("\n\n\n <NbClasses [%d]><NBINS-1>",NbCl1);
   printf("\n ---------------");
   for(k=(2*NbSpCl),l=0;k<(3*NbSpCl);k++,l++) 
     { SegmentationHistoCOLORKmeanFast(mat_img,TabSeg[k],length,width,NbCl1,(NBINS-1),SIZE1,k,l);
       for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; } } 

 if (NbCl2)
 { printf("\n\n\n <NbClasses [%d]><NBINS-1>",NbCl2);
   printf("\n ---------------");
   for(k=(3*NbSpCl),l=0;k<(4*NbSpCl);k++,l++) 
     { SegmentationHistoCOLORKmeanFast(mat_img,TabSeg[k],length,width,NbCl2,(NBINS-1),SIZE1,k,l);
       for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; } } 


 //------//
 // GRAD //
 //------//
 if (NbCl1)
 { printf("\n\n\n <NbClasses [%d]><NBBINGRAD>",NbCl1);
   printf("\n ---------------");
   for(k=(4*NbSpCl),l=0;k<(5*NbSpCl);k++,l++) 
     { SegmentationHistoCOLORKmeanFastG(mat_img,TabSeg[k],length,width,NbCl1,NBINSGRAD,SIZE1,k,l);
       for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; } } 

 if (NbCl2)
 { printf("\n\n\n <NbClasses [%d]><NBBINGRAD>",NbCl2);
   printf("\n ---------------");
   for(k=(5*NbSpCl),l=0;k<(6*NbSpCl);k++,l++) 
     { SegmentationHistoCOLORKmeanFastG(mat_img,TabSeg[k],length,width,NbCl2,NBINSGRAD,SIZE1,k,l);
       for(m=0;m<5;m++) if (!FuseSmallRegions(TabSeg[k],length,width,&nbreg,SIZEMIN))  break; } } 
}

//-------------------------------------------//
//----------SEGMENTATION METHODS-------------//
//-------------------------------------------//
//----------------------------------------------------------
// Fusion Model in VoI Sense
//----------------------------------------------------------    
void VOIBFM::SegmentEntrop()
{
 int k;
 int nbreg;
 char MyBuff[100]; 
 int TimeSec;
 int IndxBestSeg;

 //Stack Size Increased (128 MB)
 const rlim_t kStackSize=128*1024*1024;   
 struct rlimit rl;
 int result=getrlimit(RLIMIT_STACK,&rl);
 if (result==0)
 if (rl.rlim_cur<kStackSize)
    {  rl.rlim_cur=kStackSize;
       result=setrlimit(RLIMIT_STACK,&rl);
       if (result!=0) fprintf(stderr,"setrlimit returned result = %d\n",result); } 

 //>TimeObjet
 Chrono  chrono; 
 chrono.reset();
 TimeSec=0;

 //>Record
 strcpy(MyBuff,Extension);
 
 //>Information
 printf("\n\n SegmentEntropLoc");
 printf("\n -----------------");
 printf("\n Image: [%s] (%d - %d)",Name_Img,length,width);
 printf("\n ---------");
 //printf("\n    > Regularization      >>>  [%.3f]",Regularization);
 //printf("\n ---------\n\n");
 fflush(stdout);

 //> Constantes
 int NbSpaceCol=10;
 int NBSEGS=6*NbSpaceCol;
 
 //>MemoryAllocation
 float*** TabSegA=fmatrix_allocate_3d(NBSEGS,length,width);
 int***   TabSegB=imatrix_allocate_3d(NBSEGS,length,width);
 float**  Mat2=fmatrix_allocate_2d(length,width);
 int**    MatInt1=imatrix_allocate_2d(length,width);
 int**    MatInt2=imatrix_allocate_2d(length,width);
 int**    MatInt3=imatrix_allocate_2d(length,width);
 float*   TabVoI=fmatrix_allocate_1d(NBSEGS);

 
 //===============================================================================
 //> [0] ESTIMATION Complexity
 //===============================================================================
  float complexity=Complexity(mat_img,length,width,5,7);
  printf(" ::COMPLEXITY:: [%f] ",complexity);

  float tmp=(int)(1.5+(complexity*7));
 
  int NbCl1=(int)(tmp);
  int NbCl2=(int)(NbCl1);
  printf(" [NbCl1:%d][NbCl2:%d]",NbCl1,NbCl2);
  fflush(stdout);


 //===============================================================================
 //> [1] Multiple ColorSegmentationsRegions To Be Fused 
 //===============================================================================
 MultipleSegmentations(TabSegA,NbSpaceCol,NbCl1,NbCl2);
 for(k=0;k<NBSEGS;k++) ConvertClassRegionInf(TabSegA[k],TabSegB[k],length,width);

 //>Classification & Best->MatInt1
 IndxBestSeg=SelectSegMap(TabSegB,length,width,NBSEGS,TabVoI);
 Classify(TabSegB,length,width,NBSEGS,TabVoI);
 CopyMat(MatInt1,TabSegB[0],length,width);

 //DEBUG
 //SaveTabImagePgm("","TabSegmentations1",TabSegA,length,width,NBSEGS);
 //SaveTabImagePgm("","TabSegmentations2",TabSegB,length,width,NBSEGS);
 //exit(-1);


 //===============================================================================
 //> [2] ICM_VoILoc
 //=============================================================================== 
 //DEBUG
 //CopyMat(MatInt1,TabSegB[(int)Regularization],length,width);

 //ICM
 ICM_VoILoc(MatInt1,MatInt2,TabSegB,length,width,NBSEGS,50); 

 //ICM [n-BEST]
 // float ScoreFinal,ScoreVOI,ScoreVOIBest;
 //  if (1)
 //  {
 //    ScoreVOI=ScoreVOIBest=100;
 //    for(k=0;k<Regularization;k++)                                
 //       { CopyMat(MatInt1,TabSegB[k],length,width);
 //        ICM_VoILoc(MatInt1,MatInt2,TabSegB,length,width,NBSEGS,50);  
 //         ScoreVOI=MoyVariationInformation(MatInt2,TabSegB,length,width,NBSEGS,0);
 //         if (ScoreVOI<ScoreVOIBest) 
 //            { CopyMat(MatInt3,MatInt2,length,width);
 //              ScoreVOIBest=ScoreVOI; } }
 //    ScoreFinal=MoyVariationInformation(MatInt3,TabSegB,length,width,NBSEGS,0);
 //   printf("\n  >> ScoreFinal=%.2f",ScoreFinal);
 //    fflush(stdout);
 //    CopyMat(MatInt2,MatInt3,length,width);
 //   } 


 //===============================================================================
 //> [3] Cleaning
 //=============================================================================== 
 CopyMat(Mat2,MatInt2,length,width);

 for(k=0;k<2;k++) if (!FuseSmallRegions(Mat2,length,width,&nbreg,SIZEMIN))  break; //100
 for(k=0;k<1;k++) MedianFilter(Mat2,length,width,5); 

 //Info
 TimeSec=chrono.elapsed(SECOND); chrono.print(); 
 fflush(stdout);

 //Save
 ConvertClassRegion(Mat2,length,width);
 SaveImagePgm(Name_Img,(char*)"_Z00",Mat2,length,width);

 //Visu
 AddContourImg(Mat2,mat_cnt,length,width,3);
 CopyMat(mat_seg,Mat2,length,width);
 SaveImagePpm(Name_Img,(char*)"_Z00_CONT",mat_cnt,length,width);
 
 //FreeMemory 
 if (TabSegA)  free_fmatrix_3d(TabSegA,NBSEGS); 
 if (TabSegB)  free_imatrix_3d(TabSegB,NBSEGS); 
 if (Mat2)     free_fmatrix_2d(Mat2);
 if (MatInt1)  free_imatrix_2d(MatInt1);
 if (MatInt2)  free_imatrix_2d(MatInt2);
 if (MatInt3)  free_imatrix_2d(MatInt3);
 if (TabVoI)   free_fmatrix_1d(TabVoI); 
}


